# class BigDecimal

BigDecimal provides arbitrary-precision floating point decimal arithmetic.

## Introduction¶ ↑

Ruby provides built-in support for arbitrary precision integer arithmetic.

For example:

    42**13  #=>   1265437718438866624512

BigDecimal provides similar support for very large or very accurate floating point numbers.

Decimal arithmetic is also useful for general calculation, because it provides the correct answers people expect–whereas normal binary floating point arithmetic often introduces subtle errors because of the conversion between base 10 and base 2.

For example, try:

    sum = 0
    10_000.times do
      sum = sum + 0.0001
    end
    print sum #=> 0.9999999999999062

and contrast with the output from:

    require 'bigdecimal'

    sum = BigDecimal.new("0")
    10_000.times do
      sum = sum + BigDecimal.new("0.0001")
    end
    print sum #=> 0.1E1

Similarly:

    (BigDecimal.new("1.2") - BigDecimal("1.0")) == BigDecimal("0.2") #=> true

    (1.2 - 1.0) == 0.2 #=> false

## Special features of accurate decimal arithmetic¶ ↑

Because BigDecimal is more accurate than normal binary floating point arithmetic, it requires some special values.

### Infinity¶ ↑

BigDecimal sometimes needs to return infinity, for example if you divide a value by zero.

    BigDecimal.new("1.0") / BigDecimal.new("0.0")  #=> Infinity
    BigDecimal.new("-1.0") / BigDecimal.new("0.0")  #=> -Infinity

You can represent infinite numbers to BigDecimal using the strings `'Infinity'`, `'+Infinity'` and `'-Infinity'` (case-sensitive)

### Not a Number¶ ↑

When a computation results in an undefined value, the special value `NaN` (for 'not a number') is returned.

Example:

    BigDecimal.new("0.0") / BigDecimal.new("0.0") #=> NaN

You can also create undefined values.

NaN is never considered to be the same as any other value, even NaN itself:

    n = BigDecimal.new('NaN')
    n == 0.0 #=> false
    n == n #=> false

### Positive and negative zero¶ ↑

If a computation results in a value which is too small to be represented as a BigDecimal within the currently specified limits of precision, zero must be returned.

If the value which is too small to be represented is negative, a BigDecimal value of negative zero is returned.

    BigDecimal.new("1.0") / BigDecimal.new("-Infinity") #=> -0.0

If the value is positive, a value of positive zero is returned.

    BigDecimal.new("1.0") / BigDecimal.new("Infinity") #=> 0.0

(See ::mode for how to specify limits of precision.)

Note that `-0.0` and `0.0` are considered to be the same for the purposes of comparison.

Note also that in mathematics, there is no particular concept of negative or positive zero; true mathematical zero has no sign.

## bigdecimal/util¶ ↑

When you require `bigdecimal/util`, the to_d method will be available on BigDecimal and the native Integer, Float, Rational, and String classes:

    require 'bigdecimal/util'

    42.to_d         # => 0.42e2
    0.5.to_d        # => 0.5e0
    (2/3r).to_d(3)  # => 0.667e0
    "0.5".to_d      # => 0.5e0

## License¶ ↑

Copyright (C) 2002 by Shigeo Kobayashi <shigeo@tinyforest.gr.jp>.

BigDecimal is released under the Ruby and 2-clause BSD licenses. See LICENSE.txt for details.

Maintained by mrkn <mrkn@mrkn.jp> and ruby-core members.

Documented by zzak <zachary@zacharyscott.net>, mathew <meta@pobox.com>, and many other contributors.

### Constants

BASE

  Base value used in internal calculations. On a 32 bit system, BASE is 10000, indicating that calculation is done in groups of 4 digits. (If it were larger, BASE**2 wouldn't fit in 32 bits, so you couldn't guarantee that two groups could always be multiplied together without overflow.)

EXCEPTION_ALL

  Determines whether overflow, underflow or zero divide result in an exception being thrown. See ::mode.

EXCEPTION_INFINITY

  Determines what happens when the result of a computation is infinity. See ::mode.

EXCEPTION_NaN

  Determines what happens when the result of a computation is not a number (NaN). See ::mode.

EXCEPTION_OVERFLOW

  Determines what happens when the result of a computation is an overflow (a result too large to be represented). See ::mode.

EXCEPTION_UNDERFLOW

  Determines what happens when the result of a computation is an underflow (a result too small to be represented). See ::mode.

EXCEPTION_ZERODIVIDE

  Determines what happens when a division by zero is performed. See ::mode.

INFINITY

  Positive infinity value.

NAN

  'Not a Number' value.

ROUND_CEILING

  Round towards +Infinity. See ::mode.

ROUND_DOWN

  Indicates that values should be rounded towards zero. See ::mode.

ROUND_FLOOR

  Round towards -Infinity. See ::mode.

ROUND_HALF_DOWN

  Indicates that digits >= 6 should be rounded up, others rounded down. See ::mode.

ROUND_HALF_EVEN

  Round towards the even neighbor. See ::mode.

ROUND_HALF_UP

  Indicates that digits >= 5 should be rounded up, others rounded down. See ::mode.

ROUND_MODE

  Determines what happens when a result must be rounded in order to fit in the appropriate number of significant digits. See ::mode.

ROUND_UP

  Indicates that values should be rounded away from zero. See ::mode.

SIGN_NEGATIVE_FINITE

  Indicates that a value is negative and finite. See #sign.

SIGN_NEGATIVE_INFINITE

  Indicates that a value is negative and infinite. See #sign.

SIGN_NEGATIVE_ZERO

  Indicates that a value is -0. See #sign.

SIGN_NaN

  Indicates that a value is not a number. See #sign.

SIGN_POSITIVE_FINITE

  Indicates that a value is positive and finite. See #sign.

SIGN_POSITIVE_INFINITE

  Indicates that a value is positive and infinite. See #sign.

SIGN_POSITIVE_ZERO

  Indicates that a value is +0. See #sign.

### Public Class Methods

_load(p1) click to toggle source

Internal method used to provide marshalling support. See the Marshal module.

    static VALUE
    BigDecimal_load(VALUE self, VALUE str)
    {
        ENTER(2);
        Real *pv;
        unsigned char *pch;
        unsigned char ch;
        unsigned long m=0;

        SafeStringValue(str);
        pch = (unsigned char *)RSTRING_PTR(str);
        /* First get max prec */
        while((*pch) != (unsigned char)'\0' && (ch = *pch++) != (unsigned char)':') {
            if(!ISDIGIT(ch)) {
                rb_raise(rb_eTypeError, "load failed: invalid character in the marshaled string");
            }
            m = m*10 + (unsigned long)(ch-'0');
        }
        if (m > VpBaseFig()) m -= VpBaseFig();
        GUARD_OBJ(pv, VpNewRbClass(m, (char *)pch, self));
        m /= VpBaseFig();
        if (m && pv->MaxPrec > m) {
            pv->MaxPrec = m+1;
        }
        return ToValue(pv);
    }

double_fig click to toggle source

The ::double_fig class method returns the number of digits a Float number is allowed to have. The result depends upon the CPU and OS in use.

    static VALUE
    BigDecimal_double_fig(VALUE self)
    {
        return INT2FIX(VpDblFig());
    }

limit(digits) click to toggle source

Limit the number of significant digits in newly created BigDecimal numbers to the specified value. Rounding is performed as necessary, as specified by ::mode.

A limit of 0, the default, means no upper limit.

The limit specified by this method takes less priority over any limit specified to instance methods such as ceil, floor, truncate, or round.

    static VALUE
    BigDecimal_limit(int argc, VALUE *argv, VALUE self)
    {
        VALUE  nFig;
        VALUE  nCur = INT2NUM(VpGetPrecLimit());

        if (rb_scan_args(argc, argv, "01", &nFig) == 1) {
            int nf;
            if (NIL_P(nFig)) return nCur;
            nf = NUM2INT(nFig);
            if (nf < 0) {
                rb_raise(rb_eArgError, "argument must be positive");
            }
            VpSetPrecLimit(nf);
        }
        return nCur;
    }

mode(mode, value) click to toggle source

Controls handling of arithmetic exceptions and rounding. If no value is supplied, the current value is returned.

Six values of the mode parameter control the handling of arithmetic exceptions:

BigDecimal::EXCEPTION_NaN BigDecimal::EXCEPTION_INFINITY BigDecimal::EXCEPTION_UNDERFLOW BigDecimal::EXCEPTION_OVERFLOW BigDecimal::EXCEPTION_ZERODIVIDE BigDecimal::EXCEPTION_ALL

For each mode parameter above, if the value set is false, computation continues after an arithmetic exception of the appropriate type. When computation continues, results are as follows:

EXCEPTION_NaN

  NaN

EXCEPTION_INFINITY

  +Infinity or -Infinity

EXCEPTION_UNDERFLOW

  0

EXCEPTION_OVERFLOW

  +Infinity or -Infinity

EXCEPTION_ZERODIVIDE

  +Infinity or -Infinity

One value of the mode parameter controls the rounding of numeric values: BigDecimal::ROUND_MODE. The values it can take are:

ROUND_UP, :up

  round away from zero

ROUND_DOWN, :down, :truncate

  round towards zero (truncate)

ROUND_HALF_UP, :half_up, :default

  round towards the nearest neighbor, unless both neighbors are equidistant, in which case round away from zero. (default)

ROUND_HALF_DOWN, :half_down

  round towards the nearest neighbor, unless both neighbors are equidistant, in which case round towards zero.

ROUND_HALF_EVEN, :half_even, :banker

  round towards the nearest neighbor, unless both neighbors are equidistant, in which case round towards the even neighbor (Banker's rounding)

ROUND_CEILING, :ceiling, :ceil

  round towards positive infinity (ceil)

ROUND_FLOOR, :floor

  round towards negative infinity (floor)

    static VALUE
    BigDecimal_mode(int argc, VALUE *argv, VALUE self)
    {
        VALUE which;
        VALUE val;
        unsigned long f,fo;

        rb_scan_args(argc, argv, "11", &which, &val);
        f = (unsigned long)NUM2INT(which);

        if (f & VP_EXCEPTION_ALL) {
            /* Exception mode setting */
            fo = VpGetException();
            if (val == Qnil) return INT2FIX(fo);
            if (val != Qfalse && val!=Qtrue) {
                rb_raise(rb_eArgError, "second argument must be true or false");
                return Qnil; /* Not reached */
            }
            if (f & VP_EXCEPTION_INFINITY) {
                VpSetException((unsigned short)((val == Qtrue) ? (fo | VP_EXCEPTION_INFINITY) :
                            (fo & (~VP_EXCEPTION_INFINITY))));
            }
            fo = VpGetException();
            if (f & VP_EXCEPTION_NaN) {
                VpSetException((unsigned short)((val == Qtrue) ? (fo | VP_EXCEPTION_NaN) :
                            (fo & (~VP_EXCEPTION_NaN))));
            }
            fo = VpGetException();
            if (f & VP_EXCEPTION_UNDERFLOW) {
                VpSetException((unsigned short)((val == Qtrue) ? (fo | VP_EXCEPTION_UNDERFLOW) :
                            (fo & (~VP_EXCEPTION_UNDERFLOW))));
            }
            fo = VpGetException();
            if(f & VP_EXCEPTION_ZERODIVIDE) {
                VpSetException((unsigned short)((val == Qtrue) ? (fo | VP_EXCEPTION_ZERODIVIDE) :
                            (fo & (~VP_EXCEPTION_ZERODIVIDE))));
            }
            fo = VpGetException();
            return INT2FIX(fo);
        }
        if (VP_ROUND_MODE == f) {
            /* Rounding mode setting */
            unsigned short sw;
            fo = VpGetRoundMode();
            if (NIL_P(val)) return INT2FIX(fo);
            sw = check_rounding_mode(val);
            fo = VpSetRoundMode(sw);
            return INT2FIX(fo);
        }
        rb_raise(rb_eTypeError, "first argument for BigDecimal.mode invalid");
        return Qnil;
    }

new(initial, digits) click to toggle source

Create a new BigDecimal object.

initial

  The initial value, as an Integer, a Float, a Rational, a BigDecimal, or a String.

  If it is a String, spaces are ignored and unrecognized characters terminate the value.

digits

  The number of significant digits, as an Integer. If omitted or 0, the number of significant digits is determined from the initial value.

The actual number of significant digits used in computation is usually larger than the specified number.

#### Exceptions¶ ↑

TypeError

  If the `initial` type is neither Integer, Float, Rational, nor BigDecimal, this exception is raised.

TypeError

  If the `digits` is not an Integer, this exception is raised.

ArgumentError

  If `initial` is a Float, and the `digits` is larger than Float::DIG + 1, this exception is raised.

ArgumentError

  If the `initial` is a Float or Rational, and the `digits` value is omitted, this exception is raised.

    static VALUE
    BigDecimal_initialize(int argc, VALUE *argv, VALUE self)
    {
        ENTER(1);
        Real *pv = rb_check_typeddata(self, &BigDecimal_data_type);
        Real *x;

        GUARD_OBJ(x, BigDecimal_new(argc, argv));
        if (ToValue(x)) {
            pv = VpCopy(pv, x);
        }
        else {
            VpFree(pv);
            pv = x;
        }
        DATA_PTR(self) = pv;
        pv->obj = self;
        return self;
    }

save_exception_mode { ... } click to toggle source

Execute the provided block, but preserve the exception mode

    BigDecimal.save_exception_mode do
      BigDecimal.mode(BigDecimal::EXCEPTION_OVERFLOW, false)
      BigDecimal.mode(BigDecimal::EXCEPTION_NaN, false)

      BigDecimal.new(BigDecimal('Infinity'))
      BigDecimal.new(BigDecimal('-Infinity'))
      BigDecimal(BigDecimal.new('NaN'))
    end

For use with the BigDecimal::EXCEPTION_*

See ::mode

    static VALUE
    BigDecimal_save_exception_mode(VALUE self)
    {
        unsigned short const exception_mode = VpGetException();
        int state;
        VALUE ret = rb_protect(rb_yield, Qnil, &state);
        VpSetException(exception_mode);
        if (state) rb_jump_tag(state);
        return ret;
    }

save_limit { ... } click to toggle source

Execute the provided block, but preserve the precision limit

    BigDecimal.limit(100)
    puts BigDecimal.limit
    BigDecimal.save_limit do
        BigDecimal.limit(200)
        puts BigDecimal.limit
    end
    puts BigDecimal.limit

    static VALUE
    BigDecimal_save_limit(VALUE self)
    {
        size_t const limit = VpGetPrecLimit();
        int state;
        VALUE ret = rb_protect(rb_yield, Qnil, &state);
        VpSetPrecLimit(limit);
        if (state) rb_jump_tag(state);
        return ret;
    }

save_rounding_mode { ... } click to toggle source

Execute the provided block, but preserve the rounding mode

    BigDecimal.save_rounding_mode do
      BigDecimal.mode(BigDecimal::ROUND_MODE, :up)
      puts BigDecimal.mode(BigDecimal::ROUND_MODE)
    end

For use with the BigDecimal::ROUND_*

See ::mode

    static VALUE
    BigDecimal_save_rounding_mode(VALUE self)
    {
        unsigned short const round_mode = VpGetRoundMode();
        int state;
        VALUE ret = rb_protect(rb_yield, Qnil, &state);
        VpSetRoundMode(round_mode);
        if (state) rb_jump_tag(state);
        return ret;
    }

ver() click to toggle source

Returns the BigDecimal version number.

    static VALUE
    BigDecimal_version(VALUE self)
    {
        /*
         * 1.0.0: Ruby 1.8.0
         * 1.0.1: Ruby 1.8.1
         * 1.1.0: Ruby 1.9.3
        */
        return rb_str_new2("1.1.0");
    }

### Public Instance Methods

a % b click to toggle source

Returns the modulus from dividing by b.

See #divmod.

    static VALUE
    BigDecimal_mod(VALUE self, VALUE r)

mult(value, digits) click to toggle source

Multiply by the specified value.

e.g.

    c = a.mult(b,n)
    c = a * b

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

    static VALUE
    BigDecimal_mult(VALUE self, VALUE r)
    {
        ENTER(5);
        Real *c, *a, *b;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self, 1));
        if (RB_TYPE_P(r, T_FLOAT)) {
            b = GetVpValueWithPrec(r, DBL_DIG+1, 1);
        }
        else if (RB_TYPE_P(r, T_RATIONAL)) {
            b = GetVpValueWithPrec(r, a->Prec*VpBaseFig(), 1);
        }
        else {
            b = GetVpValue(r,0);
        }

        if (!b) return DoSomeOne(self, r, '*');
        SAVE(b);

        mx = a->Prec + b->Prec;
        GUARD_OBJ(c, VpCreateRbObject(mx *(VpBaseFig() + 1), "0"));
        VpMult(c, a, b);
        return ToValue(c);
    }

a ** n → bigdecimal click to toggle source

Returns the value raised to the power of n.

See #power.

    static VALUE
    BigDecimal_power_op(VALUE self, VALUE exp)
    {
        return BigDecimal_power(1, &exp, self);
    }

add(value, digits) click to toggle source

Add the specified value.

e.g.

    c = a.add(b,n)
    c = a + b

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

    static VALUE
    BigDecimal_add(VALUE self, VALUE r)
    {
        ENTER(5);
        Real *c, *a, *b;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self, 1));
        if (RB_TYPE_P(r, T_FLOAT)) {
            b = GetVpValueWithPrec(r, DBL_DIG+1, 1);
        }
        else if (RB_TYPE_P(r, T_RATIONAL)) {
            b = GetVpValueWithPrec(r, a->Prec*VpBaseFig(), 1);
        }
        else {
            b = GetVpValue(r, 0);
        }

        if (!b) return DoSomeOne(self,r,'+');
        SAVE(b);

        if (VpIsNaN(b)) return b->obj;
        if (VpIsNaN(a)) return a->obj;

        mx = GetAddSubPrec(a, b);
        if (mx == (size_t)-1L) {
            GUARD_OBJ(c,VpCreateRbObject(VpBaseFig() + 1, "0"));
            VpAddSub(c, a, b, 1);
        }
        else {
            GUARD_OBJ(c, VpCreateRbObject(mx * (VpBaseFig() + 1), "0"));
            if(!mx) {
                VpSetInf(c, VpGetSign(a));
            }
            else {
                VpAddSub(c, a, b, 1);
            }
        }
        return ToValue(c);
    }

+big_decimal → big_decimal click to toggle source

Return self.

    +BigDecimal('5')  #=> 0.5e1

    static VALUE
    BigDecimal_uplus(VALUE self)
    {
        return self;
    }

a - b → bigdecimal click to toggle source

Subtract the specified value.

e.g.

    c = a - b

The precision of the result value depends on the type of `b`.

If `b` is a Float, the precision of the result is Float::DIG+1.

If `b` is a BigDecimal, the precision of the result is `b`'s precision of internal representation from platform. So, it's return value is platform dependent.

    static VALUE
    BigDecimal_sub(VALUE self, VALUE r)
    {
        ENTER(5);
        Real *c, *a, *b;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self,1));
        if (RB_TYPE_P(r, T_FLOAT)) {
            b = GetVpValueWithPrec(r, DBL_DIG+1, 1);
        }
        else if (RB_TYPE_P(r, T_RATIONAL)) {
            b = GetVpValueWithPrec(r, a->Prec*VpBaseFig(), 1);
        }
        else {
            b = GetVpValue(r,0);
        }

        if (!b) return DoSomeOne(self,r,'-');
        SAVE(b);

        if (VpIsNaN(b)) return b->obj;
        if (VpIsNaN(a)) return a->obj;

        mx = GetAddSubPrec(a,b);
        if (mx == (size_t)-1L) {
            GUARD_OBJ(c,VpCreateRbObject(VpBaseFig() + 1, "0"));
            VpAddSub(c, a, b, -1);
        }
        else {
            GUARD_OBJ(c,VpCreateRbObject(mx *(VpBaseFig() + 1), "0"));
            if (!mx) {
                VpSetInf(c,VpGetSign(a));
            }
            else {
                VpAddSub(c, a, b, -1);
            }
        }
        return ToValue(c);
    }

-big_decimal → big_decimal click to toggle source

Return the negation of self.

    -BigDecimal('5')  #=> -0.5e1

    static VALUE
    BigDecimal_neg(VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        GUARD_OBJ(a, GetVpValue(self, 1));
        GUARD_OBJ(c, VpCreateRbObject(a->Prec *(VpBaseFig() + 1), "0"));
        VpAsgn(c, a, -1);
        return ToValue(c);
    }

a / b → bigdecimal click to toggle source

Divide by the specified value.

See #div.

    static VALUE
    BigDecimal_div(VALUE self, VALUE r)
    /* For c = self/r: with round operation */
    {
        ENTER(5);
        Real *c=NULL, *res=NULL, *div = NULL;
        r = BigDecimal_divide(&c, &res, &div, self, r);
        if (!NIL_P(r)) return r; /* coerced by other */
        SAVE(c); SAVE(res); SAVE(div);
        /* a/b = c + r/b */
        /* c xxxxx
           r 00000yyyyy  ==> (y/b)*BASE >= HALF_BASE
         */
        /* Round */
        if (VpHasVal(div)) { /* frac[0] must be zero for NaN,INF,Zero */
            VpInternalRound(c, 0, c->frac[c->Prec-1], (BDIGIT)(VpBaseVal() * (BDIGIT_DBL)res->frac[0] / div->frac[0]));
        }
        return ToValue(c);
    }

a < b click to toggle source

Returns true if a is less than b.

Values may be coerced to perform the comparison (see ==, #coerce).

    static VALUE
    BigDecimal_lt(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '<');
    }

a <= b click to toggle source

Returns true if a is less than or equal to b.

Values may be coerced to perform the comparison (see ==, #coerce).

    static VALUE
    BigDecimal_le(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, 'L');
    }

<=>(p1) click to toggle source

The comparison operator. a <=> b is 0 if a == b, 1 if a > b, -1 if a < b.

    static VALUE
    BigDecimal_comp(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '*');
    }

==(p1) click to toggle source

Tests for value equality; returns true if the values are equal.

The == and === operators and the eql? method have the same implementation for BigDecimal.

Values may be coerced to perform the comparison:

    BigDecimal.new('1.0') == 1.0  #=> true

    static VALUE
    BigDecimal_eq(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '=');
    }

===(p1) click to toggle source

Tests for value equality; returns true if the values are equal.

The == and === operators and the eql? method have the same implementation for BigDecimal.

Values may be coerced to perform the comparison:

    BigDecimal.new('1.0') == 1.0  #=> true

    static VALUE
    BigDecimal_eq(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '=');
    }

a > b click to toggle source

Returns true if a is greater than b.

Values may be coerced to perform the comparison (see ==, #coerce).

    static VALUE
    BigDecimal_gt(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '>');
    }

a >= b click to toggle source

Returns true if a is greater than or equal to b.

Values may be coerced to perform the comparison (see ==, #coerce)

    static VALUE
    BigDecimal_ge(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, 'G');
    }

_dump click to toggle source

Method used to provide marshalling support.

    inf = BigDecimal.new('Infinity')
      #=> Infinity
    BigDecimal._load(inf._dump)
      #=> Infinity

See the Marshal module.

    static VALUE
    BigDecimal_dump(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        Real *vp;
        char *psz;
        VALUE dummy;
        volatile VALUE dump;

        rb_scan_args(argc, argv, "01", &dummy);
        GUARD_OBJ(vp,GetVpValue(self, 1));
        dump = rb_str_new(0, VpNumOfChars(vp, "E")+50);
        psz = RSTRING_PTR(dump);
        sprintf(psz, "%"PRIuSIZE":", VpMaxPrec(vp)*VpBaseFig());
        VpToString(vp, psz+strlen(psz), 0, 0);
        rb_str_resize(dump, strlen(psz));
        return dump;
    }

abs → big_decimal click to toggle source

Returns the absolute value, as a BigDecimal.

    BigDecimal('5').abs  #=> 0.5e1
    BigDecimal('-3').abs #=> 0.3e1

    static VALUE
    BigDecimal_abs(VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec *(VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpAsgn(c, a, 1);
        VpChangeSign(c, 1);
        return ToValue(c);
    }

add(value, digits) click to toggle source

    +

Add the specified value.

e.g.

    c = a.add(b,n)
    c = a + b

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

    static VALUE
    BigDecimal_add2(VALUE self, VALUE b, VALUE n)
    {
        ENTER(2);
        Real *cv;
        SIGNED_VALUE mx = GetPositiveInt(n);
        if (mx == 0) return BigDecimal_add(self, b);
        else {
            size_t pl = VpSetPrecLimit(0);
            VALUE   c = BigDecimal_add(self, b);
            VpSetPrecLimit(pl);
            GUARD_OBJ(cv, GetVpValue(c, 1));
            VpLeftRound(cv, VpGetRoundMode(), mx);
            return ToValue(cv);
        }
    }

ceil(n) click to toggle source

Return the smallest integer greater than or equal to the value, as a BigDecimal.

    BigDecimal('3.14159').ceil #=> 4
    BigDecimal('-9.1').ceil #=> -9

If n is specified and positive, the fractional part of the result has no more than that many digits.

If n is specified and negative, at least that many digits to the left of the decimal point will be 0 in the result.

    BigDecimal('3.14159').ceil(3) #=> 3.142
    BigDecimal('13345.234').ceil(-2) #=> 13400.0

    static VALUE
    BigDecimal_ceil(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        int iLoc;
        VALUE vLoc;
        size_t mx, pl = VpSetPrecLimit(0);

        if (rb_scan_args(argc, argv, "01", &vLoc) == 0) {
            iLoc = 0;
        } else {
            iLoc = NUM2INT(vLoc);
        }

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpSetPrecLimit(pl);
        VpActiveRound(c, a, VP_ROUND_CEIL, iLoc);
        if (argc == 0) {
            return BigDecimal_to_i(ToValue(c));
        }
        return ToValue(c);
    }

coerce(p1) click to toggle source

The coerce method provides support for Ruby type coercion. It is not enabled by default.

This means that binary operations like + * / or - can often be performed on a BigDecimal and an object of another type, if the other object can be coerced into a BigDecimal value.

e.g.

    a = BigDecimal.new("1.0")
    b = a / 2.0 #=> 0.5

Note that coercing a String to a BigDecimal is not supported by default; it requires a special compile-time option when building Ruby.

    static VALUE
    BigDecimal_coerce(VALUE self, VALUE other)
    {
        ENTER(2);
        VALUE obj;
        Real *b;

        if (RB_TYPE_P(other, T_FLOAT)) {
            GUARD_OBJ(b, GetVpValueWithPrec(other, DBL_DIG+1, 1));
            obj = rb_assoc_new(ToValue(b), self);
        }
        else {
            if (RB_TYPE_P(other, T_RATIONAL)) {
                Real* pv = DATA_PTR(self);
                GUARD_OBJ(b, GetVpValueWithPrec(other, pv->Prec*VpBaseFig(), 1));
            }
            else {
                GUARD_OBJ(b, GetVpValue(other, 1));
            }
            obj = rb_assoc_new(b->obj, self);
        }

        return obj;
    }

div(value, digits) → bigdecimal or integer click to toggle source

Divide by the specified value.

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

  If digits is 0, the result is the same as for the / operator or quo.

  If digits is not specified, the result is an integer, by analogy with Float#div; see also #divmod.

Examples:

    a = BigDecimal("4")
    b = BigDecimal("3")

    a.div(b, 3)  # => 0.133e1

    a.div(b, 0)  # => 0.1333333333333333333e1
    a / b        # => 0.1333333333333333333e1
    a.quo(b)     # => 0.1333333333333333333e1

    a.div(b)     # => 1

    static VALUE
    BigDecimal_div3(int argc, VALUE *argv, VALUE self)
    {
        VALUE b,n;

        rb_scan_args(argc, argv, "11", &b, &n);

        return BigDecimal_div2(self, b, n);
    }

divmod(value) click to toggle source

Divides by the specified value, and returns the quotient and modulus as BigDecimal numbers. The quotient is rounded towards negative infinity.

For example:

    require 'bigdecimal'

    a = BigDecimal.new("42")
    b = BigDecimal.new("9")

    q, m = a.divmod(b)

    c = q * b + m

    a == c  #=> true

The quotient q is (a/b).floor, and the modulus is the amount that must be added to q * b to get a.

    static VALUE
    BigDecimal_divmod(VALUE self, VALUE r)
    {
        ENTER(5);
        Real *div = NULL, *mod = NULL;

        if (BigDecimal_DoDivmod(self, r, &div, &mod)) {
            SAVE(div); SAVE(mod);
            return rb_assoc_new(ToValue(div), ToValue(mod));
        }
        return DoSomeOne(self,r,rb_intern("divmod"));
    }

eql?(p1) click to toggle source

Tests for value equality; returns true if the values are equal.

The == and === operators and the eql? method have the same implementation for BigDecimal.

Values may be coerced to perform the comparison:

    BigDecimal.new('1.0') == 1.0  #=> true

    static VALUE
    BigDecimal_eq(VALUE self, VALUE r)
    {
        return BigDecimalCmp(self, r, '=');
    }

exponent() click to toggle source

Returns the exponent of the BigDecimal number, as an Integer.

If the number can be represented as 0.xxxxxx*10**n where xxxxxx is a string of digits with no leading zeros, then n is the exponent.

    static VALUE
    BigDecimal_exponent(VALUE self)
    {
        ssize_t e = VpExponent10(GetVpValue(self, 1));
        return INT2NUM(e);
    }

finite?() click to toggle source

Returns True if the value is finite (not NaN or infinite).

    static VALUE
    BigDecimal_IsFinite(VALUE self)
    {
        Real *p = GetVpValue(self, 1);
        if (VpIsNaN(p)) return Qfalse;
        if (VpIsInf(p)) return Qfalse;
        return Qtrue;
    }

fix() click to toggle source

Return the integer part of the number, as a BigDecimal.

    static VALUE
    BigDecimal_fix(VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec *(VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpActiveRound(c, a, VP_ROUND_DOWN, 0); /* 0: round off */
        return ToValue(c);
    }

floor(n) click to toggle source

Return the largest integer less than or equal to the value, as a BigDecimal.

    BigDecimal('3.14159').floor #=> 3
    BigDecimal('-9.1').floor #=> -10

If n is specified and positive, the fractional part of the result has no more than that many digits.

If n is specified and negative, at least that many digits to the left of the decimal point will be 0 in the result.

    BigDecimal('3.14159').floor(3) #=> 3.141
    BigDecimal('13345.234').floor(-2) #=> 13300.0

    static VALUE
    BigDecimal_floor(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        int iLoc;
        VALUE vLoc;
        size_t mx, pl = VpSetPrecLimit(0);

        if (rb_scan_args(argc, argv, "01", &vLoc)==0) {
            iLoc = 0;
        }
        else {
            iLoc = NUM2INT(vLoc);
        }

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpSetPrecLimit(pl);
        VpActiveRound(c, a, VP_ROUND_FLOOR, iLoc);
    #ifdef BIGDECIMAL_DEBUG
        VPrint(stderr, "floor: c=%\n", c);
    #endif
        if (argc == 0) {
            return BigDecimal_to_i(ToValue(c));
        }
        return ToValue(c);
    }

frac() click to toggle source

Return the fractional part of the number, as a BigDecimal.

    static VALUE
    BigDecimal_frac(VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        size_t mx;

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpFrac(c, a);
        return ToValue(c);
    }

hash click to toggle source

Creates a hash for this BigDecimal.

Two BigDecimals with equal sign, fractional part and exponent have the same hash.

    static VALUE
    BigDecimal_hash(VALUE self)
    {
        ENTER(1);
        Real *p;
        st_index_t hash;

        GUARD_OBJ(p, GetVpValue(self, 1));
        hash = (st_index_t)p->sign;
        /* hash!=2: the case for 0(1),NaN(0) or +-Infinity(3) is sign itself */
        if(hash == 2 || hash == (st_index_t)-2) {
            hash ^= rb_memhash(p->frac, sizeof(BDIGIT)*p->Prec);
            hash += p->exponent;
        }
        return INT2FIX(hash);
    }

infinite?() click to toggle source

Returns nil, -1, or +1 depending on whether the value is finite, -Infinity, or +Infinity.

    static VALUE
    BigDecimal_IsInfinite(VALUE self)
    {
        Real *p = GetVpValue(self, 1);
        if (VpIsPosInf(p)) return INT2FIX(1);
        if (VpIsNegInf(p)) return INT2FIX(-1);
        return Qnil;
    }

inspect() click to toggle source

Returns debugging information about the value as a string of comma-separated values in angle brackets with a leading #:

    BigDecimal.new("1234.5678").inspect
      #=> "0.12345678e4"

The first part is the address, the second is the value as a string, and the final part ss(mm) is the current number of significant digits and the maximum number of significant digits, respectively.

    static VALUE
    BigDecimal_inspect(VALUE self)
    {
        ENTER(5);
        Real *vp;
        volatile VALUE str;
        size_t nc;

        GUARD_OBJ(vp, GetVpValue(self, 1));
        nc = VpNumOfChars(vp, "E");

        str = rb_str_new(0, nc);
        VpToString(vp, RSTRING_PTR(str), 0, 0);
        rb_str_resize(str, strlen(RSTRING_PTR(str)));
        return str;
    }

modulo(b) click to toggle source

Returns the modulus from dividing by b.

See #divmod.

    static VALUE
    BigDecimal_mod(VALUE self, VALUE r)

mult(value, digits) click to toggle source

Multiply by the specified value.

e.g.

    c = a.mult(b,n)
    c = a * b

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

    static VALUE
    BigDecimal_mult2(VALUE self, VALUE b, VALUE n)
    {
        ENTER(2);
        Real *cv;
        SIGNED_VALUE mx = GetPositiveInt(n);
        if (mx == 0) return BigDecimal_mult(self, b);
        else {
            size_t pl = VpSetPrecLimit(0);
            VALUE   c = BigDecimal_mult(self, b);
            VpSetPrecLimit(pl);
            GUARD_OBJ(cv, GetVpValue(c, 1));
            VpLeftRound(cv, VpGetRoundMode(), mx);
            return ToValue(cv);
        }
    }

nan?() click to toggle source

Returns True if the value is Not a Number.

    static VALUE
    BigDecimal_IsNaN(VALUE self)
    {
        Real *p = GetVpValue(self, 1);
        if (VpIsNaN(p))  return Qtrue;
        return Qfalse;
    }

nonzero?() click to toggle source

Returns self if the value is non-zero, nil otherwise.

    static VALUE
    BigDecimal_nonzero(VALUE self)
    {
        Real *a = GetVpValue(self, 1);
        return VpIsZero(a) ? Qnil : self;
    }

power(n) click to toggle source
power(n, prec)

Returns the value raised to the power of n.

Note that n must be an Integer.

Also available as the operator **.

    static VALUE
    BigDecimal_power(int argc, VALUE*argv, VALUE self)
    {
        ENTER(5);
        VALUE vexp, prec;
        Real* exp = NULL;
        Real *x, *y;
        ssize_t mp, ma, n;
        SIGNED_VALUE int_exp;
        double d;

        rb_scan_args(argc, argv, "11", &vexp, &prec);

        GUARD_OBJ(x, GetVpValue(self, 1));
        n = NIL_P(prec) ? (ssize_t)(x->Prec*VpBaseFig()) : NUM2SSIZET(prec);

        if (VpIsNaN(x)) {
            y = VpCreateRbObject(n, "0#");
            RB_GC_GUARD(y->obj);
            VpSetNaN(y);
            return ToValue(y);
        }

      retry:
        switch (TYPE(vexp)) {
          case T_FIXNUM:
            break;

          case T_BIGNUM:
            break;

          case T_FLOAT:
            d = RFLOAT_VALUE(vexp);
            if (d == round(d)) {
                if (FIXABLE(d)) {
                    vexp = LONG2FIX((long)d);
                }
                else {
                    vexp = rb_dbl2big(d);
                }
                goto retry;
            }
            exp = GetVpValueWithPrec(vexp, DBL_DIG+1, 1);
            break;

          case T_RATIONAL:
            if (is_zero(rb_rational_num(vexp))) {
                if (is_positive(vexp)) {
                    vexp = INT2FIX(0);
                    goto retry;
                }
            }
            else if (is_one(rb_rational_den(vexp))) {
                vexp = rb_rational_num(vexp);
                goto retry;
            }
            exp = GetVpValueWithPrec(vexp, n, 1);
            break;

          case T_DATA:
            if (is_kind_of_BigDecimal(vexp)) {
                VALUE zero = INT2FIX(0);
                VALUE rounded = BigDecimal_round(1, &zero, vexp);
                if (RTEST(BigDecimal_eq(vexp, rounded))) {
                    vexp = BigDecimal_to_i(vexp);
                    goto retry;
                }
                exp = DATA_PTR(vexp);
                break;
            }
            /* fall through */
          default:
            rb_raise(rb_eTypeError,
                     "wrong argument type %"PRIsVALUE" (expected scalar Numeric)",
                     RB_OBJ_CLASSNAME(vexp));
        }

        if (VpIsZero(x)) {
            if (is_negative(vexp)) {
                y = VpCreateRbObject(n, "#0");
                RB_GC_GUARD(y->obj);
                if (BIGDECIMAL_NEGATIVE_P(x)) {
                    if (is_integer(vexp)) {
                        if (is_even(vexp)) {
                            /* (-0) ** (-even_integer)  -> Infinity */
                            VpSetPosInf(y);
                        }
                        else {
                            /* (-0) ** (-odd_integer)  -> -Infinity */
                            VpSetNegInf(y);
                        }
                    }
                    else {
                        /* (-0) ** (-non_integer)  -> Infinity */
                        VpSetPosInf(y);
                    }
                }
                else {
                    /* (+0) ** (-num)  -> Infinity */
                    VpSetPosInf(y);
                }
                return ToValue(y);
            }
            else if (is_zero(vexp)) {
                return ToValue(VpCreateRbObject(n, "1"));
            }
            else {
                return ToValue(VpCreateRbObject(n, "0"));
            }
        }

        if (is_zero(vexp)) {
            return ToValue(VpCreateRbObject(n, "1"));
        }
        else if (is_one(vexp)) {
            return self;
        }

        if (VpIsInf(x)) {
            if (is_negative(vexp)) {
                if (BIGDECIMAL_NEGATIVE_P(x)) {
                    if (is_integer(vexp)) {
                        if (is_even(vexp)) {
                            /* (-Infinity) ** (-even_integer) -> +0 */
                            return ToValue(VpCreateRbObject(n, "0"));
                        }
                        else {
                            /* (-Infinity) ** (-odd_integer) -> -0 */
                            return ToValue(VpCreateRbObject(n, "-0"));
                        }
                    }
                    else {
                        /* (-Infinity) ** (-non_integer) -> -0 */
                        return ToValue(VpCreateRbObject(n, "-0"));
                    }
                }
                else {
                    return ToValue(VpCreateRbObject(n, "0"));
                }
            }
            else {
                y = VpCreateRbObject(n, "0#");
                if (BIGDECIMAL_NEGATIVE_P(x)) {
                    if (is_integer(vexp)) {
                        if (is_even(vexp)) {
                            VpSetPosInf(y);
                        }
                        else {
                            VpSetNegInf(y);
                        }
                    }
                    else {
                        /* TODO: support complex */
                        rb_raise(rb_eMathDomainError,
                                 "a non-integral exponent for a negative base");
                    }
                }
                else {
                    VpSetPosInf(y);
                }
                return ToValue(y);
            }
        }

        if (exp != NULL) {
            return rmpd_power_by_big_decimal(x, exp, n);
        }
        else if (RB_TYPE_P(vexp, T_BIGNUM)) {
            VALUE abs_value = BigDecimal_abs(self);
            if (is_one(abs_value)) {
                return ToValue(VpCreateRbObject(n, "1"));
            }
            else if (RTEST(rb_funcall(abs_value, '<', 1, INT2FIX(1)))) {
                if (is_negative(vexp)) {
                    y = VpCreateRbObject(n, "0#");
                    if (is_even(vexp)) {
                        VpSetInf(y, VpGetSign(x));
                    }
                    else {
                        VpSetInf(y, -VpGetSign(x));
                    }
                    return ToValue(y);
                }
                else if (BIGDECIMAL_NEGATIVE_P(x) && is_even(vexp)) {
                    return ToValue(VpCreateRbObject(n, "-0"));
                }
                else {
                    return ToValue(VpCreateRbObject(n, "0"));
                }
            }
            else {
                if (is_positive(vexp)) {
                    y = VpCreateRbObject(n, "0#");
                    if (is_even(vexp)) {
                        VpSetInf(y, VpGetSign(x));
                    }
                    else {
                        VpSetInf(y, -VpGetSign(x));
                    }
                    return ToValue(y);
                }
                else if (BIGDECIMAL_NEGATIVE_P(x) && is_even(vexp)) {
                    return ToValue(VpCreateRbObject(n, "-0"));
                }
                else {
                    return ToValue(VpCreateRbObject(n, "0"));
                }
            }
        }

        int_exp = FIX2LONG(vexp);
        ma = int_exp;
        if (ma <  0) ma = -ma;
        if (ma == 0) ma = 1;

        if (VpIsDef(x)) {
            mp = x->Prec * (VpBaseFig() + 1);
            GUARD_OBJ(y, VpCreateRbObject(mp * (ma + 1), "0"));
        }
        else {
            GUARD_OBJ(y, VpCreateRbObject(1, "0"));
        }
        VpPower(y, x, int_exp);
        if (!NIL_P(prec) && VpIsDef(y)) {
            VpMidRound(y, VpGetRoundMode(), n);
        }
        return ToValue(y);
    }

precs → array click to toggle source

Returns an Array of two Integer values.

The first value is the current number of significant digits in the BigDecimal. The second value is the maximum number of significant digits for the BigDecimal.

    BigDecimal('5').precs #=> [9, 18]

    static VALUE
    BigDecimal_prec(VALUE self)
    {
        ENTER(1);
        Real *p;
        VALUE obj;

        GUARD_OBJ(p, GetVpValue(self, 1));
        obj = rb_assoc_new(INT2NUM(p->Prec*VpBaseFig()),
                           INT2NUM(p->MaxPrec*VpBaseFig()));
        return obj;
    }

quo(value) → bigdecimal click to toggle source

Divide by the specified value.

See #div.

    static VALUE
    BigDecimal_div(VALUE self, VALUE r)
    /* For c = self/r: with round operation */
    {
        ENTER(5);
        Real *c=NULL, *res=NULL, *div = NULL;
        r = BigDecimal_divide(&c, &res, &div, self, r);
        if (!NIL_P(r)) return r; /* coerced by other */
        SAVE(c); SAVE(res); SAVE(div);
        /* a/b = c + r/b */
        /* c xxxxx
           r 00000yyyyy  ==> (y/b)*BASE >= HALF_BASE
         */
        /* Round */
        if (VpHasVal(div)) { /* frac[0] must be zero for NaN,INF,Zero */
            VpInternalRound(c, 0, c->frac[c->Prec-1], (BDIGIT)(VpBaseVal() * (BDIGIT_DBL)res->frac[0] / div->frac[0]));
        }
        return ToValue(c);
    }

remainder(value) click to toggle source

Returns the remainder from dividing by the value.

x.remainder(y) means x-y*(x/y).truncate

    static VALUE
    BigDecimal_remainder(VALUE self, VALUE r) /* remainder */
    {
        VALUE  f;
        Real  *d, *rv = 0;
        f = BigDecimal_divremain(self, r, &d, &rv);
        if (!NIL_P(f)) return f;
        return ToValue(rv);
    }

round(n, mode) click to toggle source

Round to the nearest integer (by default), returning the result as a BigDecimal.

    BigDecimal('3.14159').round #=> 3
    BigDecimal('8.7').round #=> 9
    BigDecimal('-9.9').round #=> -10

If n is specified and positive, the fractional part of the result has no more than that many digits.

If n is specified and negative, at least that many digits to the left of the decimal point will be 0 in the result.

    BigDecimal('3.14159').round(3) #=> 3.142
    BigDecimal('13345.234').round(-2) #=> 13300.0

The value of the optional mode argument can be used to determine how rounding is performed; see ::mode.

    static VALUE
    BigDecimal_round(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        Real   *c, *a;
        int    iLoc = 0;
        VALUE  vLoc;
        VALUE  vRound;
        size_t mx, pl;

        unsigned short sw = VpGetRoundMode();

        switch (rb_scan_args(argc, argv, "02", &vLoc, &vRound)) {
          case 0:
            iLoc = 0;
            break;
          case 1:
            if (RB_TYPE_P(vLoc, T_HASH)) {
                sw = check_rounding_mode_option(vLoc);
            }
            else {
                iLoc = NUM2INT(vLoc);
            }
            break;
          case 2:
            iLoc = NUM2INT(vLoc);
            if (RB_TYPE_P(vRound, T_HASH)) {
                sw = check_rounding_mode_option(vRound);
            }
            else {
                sw = check_rounding_mode(vRound);
            }
            break;
          default:
            break;
        }

        pl = VpSetPrecLimit(0);
        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpSetPrecLimit(pl);
        VpActiveRound(c, a, sw, iLoc);
        if (argc == 0) {
            return BigDecimal_to_i(ToValue(c));
        }
        return ToValue(c);
    }

sign() click to toggle source

Returns the sign of the value.

Returns a positive value if > 0, a negative value if < 0, and a zero if == 0.

The specific value returned indicates the type and sign of the BigDecimal, as follows:

BigDecimal::SIGN_NaN

  value is Not a Number

BigDecimal::SIGN_POSITIVE_ZERO

  value is +0

BigDecimal::SIGN_NEGATIVE_ZERO

  value is -0

BigDecimal::SIGN_POSITIVE_INFINITE

  value is +Infinity

BigDecimal::SIGN_NEGATIVE_INFINITE

  value is -Infinity

BigDecimal::SIGN_POSITIVE_FINITE

  value is positive

BigDecimal::SIGN_NEGATIVE_FINITE

  value is negative

    static VALUE
    BigDecimal_sign(VALUE self)
    { /* sign */
        int s = GetVpValue(self, 1)->sign;
        return INT2FIX(s);
    }

split() click to toggle source

Splits a BigDecimal number into four parts, returned as an array of values.

The first value represents the sign of the BigDecimal, and is -1 or 1, or 0 if the BigDecimal is Not a Number.

The second value is a string representing the significant digits of the BigDecimal, with no leading zeros.

The third value is the base used for arithmetic (currently always 10) as an Integer.

The fourth value is an Integer exponent.

If the BigDecimal can be represented as 0.xxxxxx*10**n, then xxxxxx is the string of significant digits with no leading zeros, and n is the exponent.

From these values, you can translate a BigDecimal to a float as follows:

    sign, significant_digits, base, exponent = a.split
    f = sign * "0.#{significant_digits}".to_f * (base ** exponent)

(Note that the #to_f method is provided as a more convenient way to translate a BigDecimal to a Float.)

    static VALUE
    BigDecimal_split(VALUE self)
    {
        ENTER(5);
        Real *vp;
        VALUE obj,str;
        ssize_t e, s;
        char *psz1;

        GUARD_OBJ(vp, GetVpValue(self, 1));
        str = rb_str_new(0, VpNumOfChars(vp, "E"));
        psz1 = RSTRING_PTR(str);
        VpSzMantissa(vp, psz1);
        s = 1;
        if(psz1[0] == '-') {
            size_t len = strlen(psz1 + 1);

            memmove(psz1, psz1 + 1, len);
            psz1[len] = '\0';
            s = -1;
        }
        if (psz1[0] == 'N') s = 0; /* NaN */
        e = VpExponent10(vp);
        obj = rb_ary_new2(4);
        rb_ary_push(obj, INT2FIX(s));
        rb_ary_push(obj, str);
        rb_str_resize(str, strlen(psz1));
        rb_ary_push(obj, INT2FIX(10));
        rb_ary_push(obj, INT2NUM(e));
        return obj;
    }

sqrt(n) click to toggle source

Returns the square root of the value.

Result has at least n significant digits.

    static VALUE
    BigDecimal_sqrt(VALUE self, VALUE nFig)
    {
        ENTER(5);
        Real *c, *a;
        size_t mx, n;

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);

        n = GetPositiveInt(nFig) + VpDblFig() + BASE_FIG;
        if (mx <= n) mx = n;
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpSqrt(c, a);
        return ToValue(c);
    }

sub(value, digits) → bigdecimal click to toggle source

Subtract the specified value.

e.g.

    c = a.sub(b,n)

digits

  If specified and less than the number of significant digits of the result, the result is rounded to that number of digits, according to ::mode.

    static VALUE
    BigDecimal_sub2(VALUE self, VALUE b, VALUE n)
    {
        ENTER(2);
        Real *cv;
        SIGNED_VALUE mx = GetPositiveInt(n);
        if (mx == 0) return BigDecimal_sub(self, b);
        else {
            size_t pl = VpSetPrecLimit(0);
            VALUE   c = BigDecimal_sub(self, b);
            VpSetPrecLimit(pl);
            GUARD_OBJ(cv, GetVpValue(c, 1));
            VpLeftRound(cv, VpGetRoundMode(), mx);
            return ToValue(cv);
        }
    }

to_d → bigdecimal click to toggle source

Returns self.

    require 'bigdecimal/util'

    d = BigDecimal.new("3.14")
    d.to_d                       # => 0.314e1

    # File lib/bigdecimal/util.rb, line 109
    def to_d
      self
    end

to_digits → string click to toggle source

Converts a BigDecimal to a String of the form “nnnnnn.mmm”. This method is deprecated; use #to_s(“F”) instead.

    require 'bigdecimal/util'

    d = BigDecimal.new("3.14")
    d.to_digits                  # => "3.14"

    # File lib/bigdecimal/util.rb, line 89
    def to_digits
      if self.nan? || self.infinite? || self.zero?
        self.to_s
      else
        i       = self.to_i.to_s
        _,f,_,z = self.frac.split
        i + "." + ("0"*(-z)) + f
      end
    end

to_f() click to toggle source

Returns a new Float object having approximately the same value as the BigDecimal number. Normal accuracy limits and built-in errors of binary Float arithmetic apply.

    static VALUE
    BigDecimal_to_f(VALUE self)
    {
        ENTER(1);
        Real *p;
        double d;
        SIGNED_VALUE e;
        char *buf;
        volatile VALUE str;

        GUARD_OBJ(p, GetVpValue(self, 1));
        if (VpVtoD(&d, &e, p) != 1)
            return rb_float_new(d);
        if (e > (SIGNED_VALUE)(DBL_MAX_10_EXP+BASE_FIG))
            goto overflow;
        if (e < (SIGNED_VALUE)(DBL_MIN_10_EXP-BASE_FIG))
            goto underflow;

        str = rb_str_new(0, VpNumOfChars(p, "E"));
        buf = RSTRING_PTR(str);
        VpToString(p, buf, 0, 0);
        errno = 0;
        d = strtod(buf, 0);
        if (errno == ERANGE) {
            if (d == 0.0) goto underflow;
            if (fabs(d) >= HUGE_VAL) goto overflow;
        }
        return rb_float_new(d);

    overflow:
        VpException(VP_EXCEPTION_OVERFLOW, "BigDecimal to Float conversion", 0);
        if (BIGDECIMAL_NEGATIVE_P(p))
            return rb_float_new(VpGetDoubleNegInf());
        else
            return rb_float_new(VpGetDoublePosInf());

    underflow:
        VpException(VP_EXCEPTION_UNDERFLOW, "BigDecimal to Float conversion", 0);
        if (BIGDECIMAL_NEGATIVE_P(p))
            return rb_float_new(-0.0);
        else
            return rb_float_new(0.0);
    }

to_i() click to toggle source

Returns the value as an Integer.

If the BigDecimal is infinity or NaN, raises FloatDomainError.

    static VALUE
    BigDecimal_to_i(VALUE self)
    {
        ENTER(5);
        ssize_t e, nf;
        Real *p;

        GUARD_OBJ(p, GetVpValue(self, 1));
        BigDecimal_check_num(p);

        e = VpExponent10(p);
        if (e <= 0) return INT2FIX(0);
        nf = VpBaseFig();
        if (e <= nf) {
            return LONG2NUM((long)(VpGetSign(p) * (BDIGIT_DBL_SIGNED)p->frac[0]));
        }
        else {
            VALUE a = BigDecimal_split(self);
            VALUE digits = RARRAY_AREF(a, 1);
            VALUE numerator = rb_funcall(digits, rb_intern("to_i"), 0);
            VALUE ret;
            ssize_t dpower = e - (ssize_t)RSTRING_LEN(digits);

            if (BIGDECIMAL_NEGATIVE_P(p)) {
                numerator = rb_funcall(numerator, '*', 1, INT2FIX(-1));
            }
            if (dpower < 0) {
                ret = rb_funcall(numerator, rb_intern("div"), 1,
                                  rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                             INT2FIX(-dpower)));
            }
            else {
                ret = rb_funcall(numerator, '*', 1,
                                 rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                            INT2FIX(dpower)));
            }
            if (RB_TYPE_P(ret, T_FLOAT)) {
                rb_raise(rb_eFloatDomainError, "Infinity");
            }
            return ret;
        }
    }

to_int() click to toggle source

Returns the value as an Integer.

If the BigDecimal is infinity or NaN, raises FloatDomainError.

    static VALUE
    BigDecimal_to_i(VALUE self)
    {
        ENTER(5);
        ssize_t e, nf;
        Real *p;

        GUARD_OBJ(p, GetVpValue(self, 1));
        BigDecimal_check_num(p);

        e = VpExponent10(p);
        if (e <= 0) return INT2FIX(0);
        nf = VpBaseFig();
        if (e <= nf) {
            return LONG2NUM((long)(VpGetSign(p) * (BDIGIT_DBL_SIGNED)p->frac[0]));
        }
        else {
            VALUE a = BigDecimal_split(self);
            VALUE digits = RARRAY_AREF(a, 1);
            VALUE numerator = rb_funcall(digits, rb_intern("to_i"), 0);
            VALUE ret;
            ssize_t dpower = e - (ssize_t)RSTRING_LEN(digits);

            if (BIGDECIMAL_NEGATIVE_P(p)) {
                numerator = rb_funcall(numerator, '*', 1, INT2FIX(-1));
            }
            if (dpower < 0) {
                ret = rb_funcall(numerator, rb_intern("div"), 1,
                                  rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                             INT2FIX(-dpower)));
            }
            else {
                ret = rb_funcall(numerator, '*', 1,
                                 rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                            INT2FIX(dpower)));
            }
            if (RB_TYPE_P(ret, T_FLOAT)) {
                rb_raise(rb_eFloatDomainError, "Infinity");
            }
            return ret;
        }
    }

to_r() click to toggle source

Converts a BigDecimal to a Rational.

    static VALUE
    BigDecimal_to_r(VALUE self)
    {
        Real *p;
        ssize_t sign, power, denomi_power;
        VALUE a, digits, numerator;

        p = GetVpValue(self, 1);
        BigDecimal_check_num(p);

        sign = VpGetSign(p);
        power = VpExponent10(p);
        a = BigDecimal_split(self);
        digits = RARRAY_AREF(a, 1);
        denomi_power = power - RSTRING_LEN(digits);
        numerator = rb_funcall(digits, rb_intern("to_i"), 0);

        if (sign < 0) {
            numerator = rb_funcall(numerator, '*', 1, INT2FIX(-1));
        }
        if (denomi_power < 0) {
            return rb_Rational(numerator,
                               rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                          INT2FIX(-denomi_power)));
        }
        else {
            return rb_Rational1(rb_funcall(numerator, '*', 1,
                                           rb_funcall(INT2FIX(10), rb_intern("**"), 1,
                                                      INT2FIX(denomi_power))));
        }
    }

to_s(s) click to toggle source

Converts the value to a string.

The default format looks like 0.xxxxEnn.

The optional parameter s consists of either an integer; or an optional '+' or ' ', followed by an optional number, followed by an optional 'E' or 'F'.

If there is a '+' at the start of s, positive values are returned with a leading '+'.

A space at the start of s returns positive values with a leading space.

If s contains a number, a space is inserted after each group of that many fractional digits.

If s ends with an 'E', engineering notation (0.xxxxEnn) is used.

If s ends with an 'F', conventional floating point notation is used.

Examples:

    BigDecimal.new('-123.45678901234567890').to_s('5F')
      #=> '-123.45678 90123 45678 9'

    BigDecimal.new('123.45678901234567890').to_s('+8F')
      #=> '+123.45678901 23456789'

    BigDecimal.new('123.45678901234567890').to_s(' F')
      #=> ' 123.4567890123456789'

    static VALUE
    BigDecimal_to_s(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        int   fmt = 0;   /* 0:E format */
        int   fPlus = 0; /* =0:default,=1: set ' ' before digits ,set '+' before digits. */
        Real  *vp;
        volatile VALUE str;
        char  *psz;
        char   ch;
        size_t nc, mc = 0;
        VALUE  f;

        GUARD_OBJ(vp, GetVpValue(self, 1));

        if (rb_scan_args(argc, argv, "01", &f) == 1) {
            if (RB_TYPE_P(f, T_STRING)) {
                SafeStringValue(f);
                psz = RSTRING_PTR(f);
                if (*psz == ' ') {
                    fPlus = 1;
                    psz++;
                }
                else if (*psz == '+') {
                    fPlus = 2;
                    psz++;
                }
                while ((ch = *psz++) != 0) {
                    if (ISSPACE(ch)) {
                        continue;
                    }
                    if (!ISDIGIT(ch)) {
                        if (ch == 'F' || ch == 'f') {
                            fmt = 1; /* F format */
                        }
                        break;
                    }
                    mc = mc*10 + ch - '0';
                }
            }
            else {
                mc = (size_t)GetPositiveInt(f);
            }
        }
        if (fmt) {
            nc = VpNumOfChars(vp, "F");
        }
        else {
            nc = VpNumOfChars(vp, "E");
        }
        if (mc > 0) {
            nc += (nc + mc - 1) / mc + 1;
        }

        str = rb_str_new(0, nc);
        psz = RSTRING_PTR(str);

        if (fmt) {
            VpToFString(vp, psz, mc, fPlus);
        }
        else {
            VpToString (vp, psz, mc, fPlus);
        }
        rb_str_resize(str, strlen(psz));
        return str;
    }

truncate(n) click to toggle source

Truncate to the nearest integer (by default), returning the result as a BigDecimal.

    BigDecimal('3.14159').truncate #=> 3
    BigDecimal('8.7').truncate #=> 8
    BigDecimal('-9.9').truncate #=> -9

If n is specified and positive, the fractional part of the result has no more than that many digits.

If n is specified and negative, at least that many digits to the left of the decimal point will be 0 in the result.

    BigDecimal('3.14159').truncate(3) #=> 3.141
    BigDecimal('13345.234').truncate(-2) #=> 13300.0

    static VALUE
    BigDecimal_truncate(int argc, VALUE *argv, VALUE self)
    {
        ENTER(5);
        Real *c, *a;
        int iLoc;
        VALUE vLoc;
        size_t mx, pl = VpSetPrecLimit(0);

        if (rb_scan_args(argc, argv, "01", &vLoc) == 0) {
            iLoc = 0;
        }
        else {
            iLoc = NUM2INT(vLoc);
        }

        GUARD_OBJ(a, GetVpValue(self, 1));
        mx = a->Prec * (VpBaseFig() + 1);
        GUARD_OBJ(c, VpCreateRbObject(mx, "0"));
        VpSetPrecLimit(pl);
        VpActiveRound(c, a, VP_ROUND_DOWN, iLoc); /* 0: truncate */
        if (argc == 0) {
            return BigDecimal_to_i(ToValue(c));
        }
        return ToValue(c);
    }

zero?() click to toggle source

Returns True if the value is zero.

    static VALUE
    BigDecimal_zero(VALUE self)
    {
        Real *a = GetVpValue(self, 1);
        return VpIsZero(a) ? Qtrue : Qfalse;
    }